$offsymxref offsymlist

$ontext
12/2016
This is PART of the code used to analyze the Voting example of Chapter 14.
It contains ONLY the heart of the model - the concentrated (dual) and definitions related to it
Note: the program is not complete, so don't try to run it as is
$offtext
************
set  i     no. observation /1*2003/
     c     no. observation for november data /1*1353/
     k     Covariates /constant, age, agesq, education, ..../
     k1    Covariates /constant, age, agesq, education, .../
     h     no. of support points for errors /1*3/
     n     no of categories /1*2/
;

parameter
          x(i,k1)  observed aggregate outcomes (inputs  outputs  etc.)
          data(i,allvar)
          data2(c,allvar)
          xdata(i,k) keep data y and x

;

parameter alphae(h) param space for errors /

1  -1.0
2   0.0
3   1.0
/;
alphae(h)= alphae(h)/(sqrt(card(i)));

parameter alphae1(h) param space for beta0 errors /

1 -1000.0
2     0.0
3  1000.0
/;

variables
   lm(n,k1)  Lagrange multipliers
   lm_cross(n,k) Lagrange multipliers for cross entropy
;

variables

        obj  objective function
        obj_cross objective function for cross entropy
;

equations
*define equations for October case
objective   objective function
objdual     dual objective function

normalize(n,k1)   Normalizing first category to zero

*define equations for cross entropy case
objdual_cross November dual objective function for cross entropy

normalize_cross(n,k) Normalizing first category to zero
;

*Concentrated Objective - Info-metrics Multinomial (no priors, or uniform priors)
objdual..   obj =e= - sum(i,sum(n,sum(k1,y(i,n)*x(i,k1)*lm(n,k1))))
            + sum(i,log(sum(n,exp(sum(k1,x(i,k1)*lm(n,k1))))))
            + sum(i,sum(n,log(sum(h,exp(sum(k1,x(i,k1)*alphae(h)*lm(n,k1)))))));
*********

normalize(n,k1).. lm("1",k1) =e=0;

***************** With Priors ************************
*Dual Objective - GCE Multinomial
objdual_cross..   obj_cross =e= sum(c,sum(n,sum(k,y_nov(c,n)*x2(c,k)*lm_cross(n,k))))
            - sum(c,log(sum(n,(prior(c,n))*exp(sum(k,x2(c,k)*lm_cross(n,k))))))
            - sum(c,sum(n,log(sum(h,(e1_prior(c,n,h))*exp(sum(k,x2(c,k)*alphae(h)*lm_cross(n,k)))))));
*********

normalize_cross(n,k).. lm_cross("1",k) =e=0;

model dual Concentrated_InfoMetrics (GME) mulitnomial/
objdual
normalize
/;
model dual_cross Concentrated Infometrics (GCE) mulitnomial/
objdual_cross
normalize_cross
/;

*Initialization or starting values

lm.l(n,k1)=0;

*Concentrated info-metrics (GME) Problem
solve dual minimizing obj using nlp;

*Initialization or starting values for Cross Entropy

lm_cross.l(n,k)=0;

solve dual_cross maximizing obj_cross using nlp;
